-- Bale Control Unit Script (Fill Level / Bale Count Daily / Bale Count Total)
-- Created by: Farming Agency (KiBo and Bull24) - Original Authors
-- Revision:   1.0.0.0
-- Copyright:  July 2020 Farming Agency (KiBo and Bull24)
-- Created for: 4D Modding D1000 augerWagon (July 2020)
-- Permission is required to use / modify this script from original creators
augerWagonInfo = {};
augerWagonInfo.currentModName = g_currentModName;

function augerWagonInfo.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Drivable, specializations);
end;

function augerWagonInfo.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", augerWagonInfo)
end;

function augerWagonInfo.registerFunctions(vehicleType)
	SpecializationUtil.registerFunction(vehicleType, "FillLevel", augerWagonInfo.FillLevel)
end;

function augerWagonInfo:onLoad(savegame)
	if self.loadDashboardsFromXML ~= nil then
		self:loadDashboardsFromXML(
			self.xmlFile, 
			"vehicle.augerWagonInfo.dashboards", 
			
			{
				valueTypeToLoad = "fillLevel",
				valueObject = self,
				valueFunc = "FillLevel",
				minFunc = 0,
				maxFunc = 99999
			}
		);
	end;
end;


function augerWagonInfo:FillLevel()
	local augerWagonFillLevel = 0;
	
	if self:getIsActive() then	
		for counter = 1, #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer do
			if Utils.getNoNil(g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[counter].fillLevel, 0) > 0  then
				augerWagonFillLevel = augerWagonFillLevel + Utils.getNoNil(g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[counter].fillLevel, 0);
			end;
		end;
	end;

	return augerWagonFillLevel;
end;



function augerWagonInfo:getSpeci(attachedVehicle, specName, currentModName)
	local spec = attachedVehicle["spec_" .. Utils.getNoNil(currentModName, augerWagonInfo.currentModName) .. "." .. specName];
	if spec ~= nil then
        return spec;
    end;
    return attachedVehicle["spec_" .. specName];
end;